/*
	tagtypes.h

	structures for the internal format of a tagged file

*/

#include <stdio.h>

/* A tag record is a linked list of tag items */
struct tagrecord {
  char *tagname;
  char *value;
  char *delimiter;
  struct tagrecord *next;		/* pointer to the next item */
};

struct tagrecord *gettagrec(FILE *f,char *fieldbuffer);
void freetagrec(struct tagrecord *rec);
void puttagrec(FILE *f, struct tagrecord *rec);

int taggetvalue(char *value, const struct tagrecord *rec, const char *fieldname, const int maxlen);

int opentagdefaults();
int gettagdefval(const char *name, char *value);
int closetagdefaults();

FILE *opentagdesc(const struct tagrecord* headerrec);
/* Open the tag descriptor file associated with the header record, or return
NIL if it can not be opened.
*/


